<script setup lang="ts">
  const props = withDefaults(
    defineProps<{
      total: number;
      pageSize?: number;
      currentPage?: number;
      aroundItems?: number;
    }>(),
    {
      pageSize: 50,
      currentPage: 1,
      aroundItems: 1,
    },
  );

  const currentPageState = ref(props.currentPage);

  const pagesNumber = computed(() => {
    return Math.ceil(props.total / props.pageSize);
  });

  const displayedPages = computed(() => {
    if (pagesNumber.value <= 10 || (props.aroundItems * 2 + 1) * 2 >= pagesNumber.value) {
      return Array.from({ length: pagesNumber.value }, (_, index) => index + 1);
    }

    const pages: (String | Number)[] = [1];
    const start = Math.max(2, currentPageState.value - props.aroundItems);
    const end = Math.min(pagesNumber.value - 1, currentPageState.value + props.aroundItems);
    if (start > 2) {
      pages.push('...');
    }

    for (let i = start; i <= end; i++) {
      pages.push(i);
    }
    if (end < pagesNumber.value - 1) {
      pages.push('...');
    }

    pages.push(pagesNumber.value);
    return pages;
  });

  const emit = defineEmits(['update:modelValue']);
  const changePage = (page: number) => {
    currentPageState.value = page;
    emit('update:modelValue', page);
  };
</script>

<template>
  <div class="flex">
    <slot name="pre-button">
      <SwButton
        variant="action"
        class="hidden rounded-l-md rounded-r-none !px-2 md:block"
        :disabled="currentPageState <= 1"
        @click="changePage(1)"
      >
        <span class="i-sw-regular:double-chevron-left-xxs text-2xl" />
      </SwButton>
      <SwButton
        variant="action"
        class="md:border-l-none rounded-r-none !px-2 md:rounded-none"
        :disabled="currentPageState <= 1"
        @click="changePage(currentPageState - 1)"
      >
        <span class="i-sw-regular:chevron-left-xxs text-2xl" />
      </SwButton>
    </slot>

    <slot name="number-button">
      <template v-for="(pageNum, index) in displayedPages">
        <SwButton
          v-if="typeof pageNum === 'number'"
          :key="pageNum"
          :variant="pageNum === currentPageState ? 'primary' : 'action'"
          class="border-l-none !border-border w-10 rounded-none !leading-6"
          @click="changePage(pageNum)"
        >
          {{ pageNum }}
        </SwButton>
        <div
          v-else
          :key="-index"
          class="border-l-none border-border flex w-10 justify-center border leading-loose shadow"
        >
          {{ pageNum }}
        </div>
      </template>
    </slot>

    <slot name="next-button">
      <SwButton
        variant="action"
        class="border-l-none rounded-l-none !px-2 md:rounded-none"
        :disabled="currentPageState >= pagesNumber"
        @click="changePage(currentPageState + 1)"
      >
        <span class="i-sw-regular:chevron-right-xxs text-2xl" />
      </SwButton>
      <SwButton
        variant="action"
        class="border-l-none hidden rounded-l-none rounded-r-md !px-2 md:block"
        :disabled="currentPageState >= pagesNumber"
        @click="changePage(pagesNumber)"
      >
        <span class="i-sw-regular:double-chevron-right-xxs text-2xl" />
      </SwButton>
    </slot>
  </div>
</template>
